/////////////////////////////////////////////////////////////////////
// Code accompanying "Embedded Angle" column in CUJ
// Copyright (c) 2002 Miro Samek 
/////////////////////////////////////////////////////////////////////
#ifndef instrument2_h
#define instrument2_h

typedef char Note;

class Instrument {
public:
   virtual ~Instrument() {}
   virtual void playNote(Note note) = 0;
};

enum { MAX_INSTRUMENT_SIZE = 40 };

class GenericInstrument {
   char buf[MAX_INSTRUMENT_SIZE];
public:
   Instrument *operator->() { 
      return (Instrument *)buf;
   }
   Instrument const *operator->() const { 
      return (Instrument const *)buf;
   }
   Instrument *get() { // For placement new or delete
      return (Instrument *)buf;
   }
};

class Configuration {
public: 
   //...
   GenericInstrument i; 
   //...
};

#endif // instrument2_h
