#include "instrument1.h"
#include <new.h>  // for placement new
#include <iostream.h>
#include <assert.h>

class Piano : public Instrument {
   int attr; // an attribute
public: 
   Piano() { 
      assert(sizeof(*this) <= sizeof(GenericInstrument)); 
   }
   virtual void playNote(Note key); 
};

class Violin : public Instrument {
   int attr1; // an attribute
   int attr2; // another attribute
public: 
   Violin() {
      assert(sizeof(*this) <= sizeof(GenericInstrument)); 
   }
   virtual void playNote(Note key); 
};

void Piano::playNote(Note key) {
   cout << "Piano " << key << endl; 
}

void Violin::playNote(Note key) {
   cout << "Violin " << key << endl; 
}

static Configuration c1, c2;

int main() {
   new(&c1.i) Piano; // instantiate Piano
   c1.i.playNote('c');
   memcpy(&c2, &c1, sizeof(Configuration)); 
   static_cast<Instrument *>(&c2.i)->playNote('d'); 
   
   new(&c1.i) Violin; // instantiate Violin
   c1.i.playNote('e'); 
   c1 = c2; // Oops, does not copy the v-pointer!
   c1.i.playNote('f');

   return 0; 
}
